/*
 *	$Source: /@/mit/e/i/eichin/charon/xdvi.RT/RCS/path_open.c,v $
 *	$Author: eichin $
 *	$Locker:  $
 *	$Header: path_open.c,v 1.1 87/05/14 11:00:44 eichin Exp $
 *
 *	$Log:	path_open.c,v $
 * Revision 1.1  87/05/14  11:00:44  eichin
 * Initial revision
 * 
 * 
 */
#ifndef lint
static char *rcsid_path_open_c = "$Header: path_open.c,v 1.1 87/05/14 11:00:44 eichin Exp $";
#endif	lint
/*
 * path open - search for a file in a given path.
 *		-Mark Eichin...from my other random toolkits.5/14/1987
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/dir.h>

char * execat(s1, s2, si)	/* taken from /src/lib/libc/gen/execvp.c */
register char *s1, *s2;
char *si;
{
	register char *s;

	s = si;
	while (*s1 && *s1 != ':') *s++ = *s1++;
	if (si != s) *s++ = '/';
	while (*s2) *s++ = *s2++;
	*s = '\0';
	return(*s1? ++s1: 0);
}

FILE *fopen_path(pathvar,name,stat)
     register char *pathvar, *name, *stat;
{
  char tname[128];
  register char *cp = index(name,'/')?"":pathvar;
  FILE *fil;

  do {
    cp=execat(cp, name, tname);
    if((fil=fopen(tname,stat))!=NULL)
      {
	return(fil);
      }
  } while(cp);
  return(NULL);
}

FILE *fopen_font_path(pathvar,name,stat)
     register char *pathvar, *name, *stat;
{
  /* The goal here is to try to open SOMETHING, whatever it really is */
  char tname[128], family[128];
  int point, mag, len;
  register char *cp = index(name,'/')?"":pathvar;
  FILE *fil;
  DIR *dirstr;
  struct direct *dirrec;
  char qf[128], bestfil[128]; int qpt, qmag;
  int delp, delm;
  int mindelp=99999999, mindelm=99999999; int bestpt, bestmag;

  do {
    cp=execat(cp, name, tname);
    if((fil=fopen(tname,stat))!=NULL)
      {
	return(fil);
      }
  } while(cp);

  if(index(name,'/'))
    return(NULL);		/* never try again, if absolute */
  /* if we get here, we must look real hard... */

  cp = pathvar;
  point = -1;
  mag = -1;
  (void) sscanf(name,"%[^0123456789.]%d.%d",family,&point,&mag);


  len=strlen(family);
  do {
    cp=execat(cp,"",tname);
    dirstr=opendir(tname);
#ifdef DEBUG
    fprintf(stderr,"This dir:%s\n",tname);
    fprintf(stderr,"dirstr=%x,dir=<%s>\n",dirstr,tname);
    if(!dirstr) perror(tname);	/* for discovering too many open files. */
#endif DEBUG
    if(dirstr)
      {
	for(dirrec=readdir(dirstr); dirrec!=NULL; dirrec=readdir(dirstr))
	  {
	    if(dirrec->d_namlen>=len && !strncmp(dirrec->d_name,family,len))
	      {
#ifdef DEBUG
		fprintf(stderr,"Font:%s\n",dirrec->d_name);
#endif DEBUG
		qpt=(-1); qmag=(-1);
		(void) sscanf(dirrec->d_name,"%[^0123456789.]%d.%d",
			      qf,&qpt,&qmag);
		delp=abs(point-qpt); delm=abs(mag-qmag); /* mag from??? */
		if ((delp < mindelp) || (delp == mindelp && delm < mindelm))
		  {
		    mindelp=delp; mindelm=delm;
		    bestpt=qpt; bestmag=qmag;
		    strcpy(bestfil,tname);
		    strcat(bestfil,"/");
		    strcat(bestfil,dirrec->d_name);
#ifdef DEBUG
		    fprintf(stderr,"Current best:%s\n",bestfil);
#endif DEBUG
		  }
	      }
	  }
	closedir(dirstr);
      }
  } while(cp);
  if(mindelp==99999999) return(NULL);
  else 
    {
      fprintf(stderr,"Using <%s> instead of <%s>, continuing.\n",
	      rindex(bestfil,'/'),
	      name);
      return(fopen(bestfil,stat));
    }
}
